from flashtext import KeywordProcessor


CLICHES = {'bad egg', 'bed of roses', 'bee in your bonnet', 'bird in the hand is worth two in the bush', 'blast from the past', 'blot on the landscape', 'bolt from the blue', 'bull in a china shop', 'bun in the oven', 'bunch of fives', 'chain is only as strong as its weakest link', 'cheap knock-off', 'chip off the old block', 'closed mouth gathers no feet', 'cult of personality', "curate's egg", 'daniel come to judgement', 'dead ringer', 'diamond in the rough', 'diamond is forever', 'dish fit for the gods', 'drop in the bucket', 'face only a mother could love', 'faint heart never a true love knows', 'far cry', 'fate worse than death', 'feather in his cap', 'few fries short of a happy meal', 'few sandwiches short of a picnic', 'fish out of water', 'fly in the ointment', 'fool and his money are soon parted', "fool's paradise", 'foregone conclusion', 'friend in need is a friend indeed', 'frog in my throat', 'game of two halves', 'good beginning makes a good ending', 'good man is hard to find', 'good rule of thumb', 'hair of the dog that bit you', 'half-baked idea', 'horse of a different color', 'horse, a horse, my kingdom for a horse', 'house divided against itself cannot stand', 'jack of all trades and a master of none', 'journey of a thousand miles begins with the first step', 'knight in shining armor', 'knock-back', 'labour of love', "legend in one's own lifetime", 'leopard does not change its spots', 'lick and a promise', 'little bird told me', 'little knowledge is a dangerous thing', 'little of this, a little of that', 'little yeast works through the whole batch of dough', 'load of old cobblers', 'long ways away', 'lot of empty flattery', 'man after my own heart', 'man for all seasons', "man's home is his castle", 'mexican standoff', 'mexican wave', 'mickey finn', 'mind is a terrible thing to waste', 'moveable feast', 'multitude of sins', 'nation of shopkeepers', 'necessary evil', 'nest-egg', 'new lease of life', 'no-brainer', 'penny saved is a penny earned', "picture's worth a thousand words", 'pig in a poke', 'pink elephant', 'place for everything and everything in its place', 'plague on both your houses', 'riddle wrapped up in an enigma', 'rolling stone gathers no moss', 'rose by any other name would smell as sweet', 'rose is a rose is a rose', 'rum do', 'safe pair of hands', 'sea change', 'shoestring budget', 'shot across the bows', 'shot in the arm', 'shot in the dark', 'shotgun wedding', 'sight for sore eyes', 'sledgehammer to crack a nut', 'sorry sight', 'spoon full of sugar helps the medicine go down', 'sticky wicket', 'stitch in time saves nine', "stone's throw away", 'sweet deal', 'taste of his own medicine', 'thorn in the flesh', "tinker's damn", 'watched pot never boils', 'white elephant', 'wide berth', 'winning combination', "wolf in sheep's clothing", 'woman needs a man like a fish needs a bicycle', 'abandon ship', 'ablaze with light', 'above board', 'absence makes the heart grow fonder', 'absolute power corrupts absolutely', 'ace in the hole', 'ace up his sleeve', "achilles' heel", 'acid test', 'apple does not fall far from the tree', 'act the giddy goat', 'actions speak louder than words', 'after my own heart', 'young and foolish', 'airing dirty laundry', 'all bent out of shape', 'all bets are off', 'all dressed up and nowhere to go', 'all ears', 'all fingers and thumbs', 'all for one, and one for all', 'all hands on deck', 'all hands to the pump', 'all heck breaks loose', 'all hell breaks loose', "all in a day's work", 'all in due time', 'all is vanity', 'all over the map', 'all pale in comparison', 'all roads lead to rome', 'all talk and no action', 'all that glitters is not gold', 'all that jazz', 'all the bits and pieces', "all the world's a stage", 'all thumbs', 'all work and no play, makes jack a dull boy', 'all is fair in love and war', 'all is well that ends well', 'already got one paw on the chicken coop', 'alrighty then', 'altitude is determined by attitude', 'always a bridesmaid, never the bride', 'always look on the bright side', "my brother's keeper", 'an apple a day keeps the doctor away', 'an arm and a leg', 'an earful', "an idle mind is the devil's playground", 'an ill wind', 'an oldie, but a goodie', 'an ounce of prevention is worth a pound of cure', 'and you can take that to the bank', 'another day, another dollar', 'another nail in the coffin', 'ants in his pants', 'any friend of yours is a friend of mine', 'any port in a storm', 'anyhoo', 'anything goes', 'apple of my eye', 'are you a man or a mouse', 'are you fair dinkum', 'armed to the teeth', 'around the horn', 'alike as two peas in a pod', 'beautiful as the day is long', 'brown as a berry', 'busy as a bee', 'cool as a cucumber', 'dense as a london fog', 'easy as pie', 'far as the eye can see', "fine as frog's hair", 'good as gold', 'happy as a clam', 'happy as a sandboy', 'happy as larry', 'honest as the day is long', 'keen as mustard', 'luck would have it', 'old as methuselah', 'plain as the nose on your face', 'pleased as punch', 'snug as a bug in a rug', 'straight as a die', "tender as a mother's heart", 'the crow flies', 'useful as a lead balloon', 'useful as tits on a bull', 'welcome as a skunk at a lawn party', 'white as snow', 'ye sow, so shall ye reap', 'ashes to ashes, dust to dust', 'ask me no questions and i will tell you no lies', 'ask not what your country can do for you, but what you can do for your country', 'asleep at the wheel', 'ass backwards', 'ass over tea kettle', 'sixes and sevens', 'the crack of dawn', 'the drop of a hat', 'the 11th hour', 'the end of my rope', 'the end of my tether', 'the end of the day', "your wits' end", "my wits' end", 'atta boy', 'atta girl', 'ax to grind', 'babe in the woods', 'baby blues', 'baby boomer', 'back against the wall', 'back from the dead', 'back-handed comment', 'back-handed compliment', 'back in a sec', 'back in the saddle', 'back it up', 'back-seat driver', 'back-stabber', 'back the field', 'back to basics', 'back to square one', 'back to the drawing board', 'backroom boy', 'bad blood', 'bad call', 'bad hair day', 'bad seed', 'bad to the bone', 'badgered to death', 'bag and baggage', 'bag lady', 'bags all packed and ready to go', 'bait and switch', "baker's dozen", 'ball and chain', 'ball is in your court', 'balls to the wall', 'banding together to beat the odds', 'bandy words', 'bang on about', 'banging your head against a brick wall', 'bank on it', 'baptism by fire', 'baptism of fire', 'bare bones', 'barefaced liar', 'barge right in', 'barking mad', 'barking up the wrong tree', 'basket case', 'bat an eyelid', 'bat the idea around', 'bated breath', 'bats in the belfry', 'batten down the hatches', 'be afraid, be very afraid', 'be in the same boat', 'be still, my beating heart', 'be there or be square', 'bear down', 'beast with two backs', 'beat a dead horse', 'beat a hasty retreat', 'beat about the bust', 'beat around the bush', 'beat him by a long chalk', 'beat it', 'beat swords into ploughshares', 'beat the living daylights out of someone', 'beats me', 'beauty is a fading flower', 'beauty is in the eye of the beholder', 'beauty is only skin deep', 'bee in her bonnet', 'beelzebub has a devil for a sideboard', 'been there, done that', "bee's knees", 'beetle-browed', 'before you could say jack robinson', "before you were the gleam in your father's eye", 'beg the question', 'beggars can not be choosers', 'behind every great man there is a great woman', 'behind the 8 ball', 'behind the times', 'being led down the garden path', 'belle of the ball', 'bells and whistles', 'below the belt', 'belt and braces', 'belt up', 'bend over backwards', 'best bib and tucker', 'best-laid plans of mice and men', 'best thing since sliced bread', 'bet the farm', 'your bottom dollar', 'better half', 'better late than never', 'better light a candle than curse the darkness', 'better safe than sorry', 'better than a kick in the teeth', 'better than ever', 'better the devil you know than the devil you do not', 'better to have loved and lost than never to have loved at all', 'better to remain silent and be thought a fool that to speak and remove all doubt', 'between a rock and a hard place', 'between the devil and the deep blue sea', 'between two stools', 'between you, me and the bed-post', 'beware of greeks bearing gifts', 'beware the ides of march', 'beyond our ken', 'beyond the pale', 'big as a house', 'big as life', 'big cheese', 'big fish in a small pond', 'big picture', 'big-wig', 'bigger they are, the harder they fall', 'billy no-mates', 'biological clock is ticking', 'bird in a gilded cage', 'bird in the hand is worth 2 in the bush', 'birds of a feather flock together', 'bite me', 'bite off more than you can chew', 'bite the bullet', 'bite the dust', 'bite your tongue', 'black as pitch', 'blackball someone', 'black sheep of the family', 'black-on-black', 'blast from the past', 'blaze a new trail', 'bleed like a stuck pig', 'blew him away', 'blew his wad', 'blind as a bat', 'blind leading the blind', 'blonde bombshell', 'blood and thunder', 'blood brothers', 'blood is thicker than water', 'blood money', 'bloody-minded', 'bloom is off the rose', 'blow a gasket', 'blow chunks', 'blow me down', 'blow the whistle on', 'blow this joint', 'blow your brains out', 'blow your mind', 'blow your own trumpet', 'blowing smoke', 'blowing smoke up my ass', 'blowing smoke up his ass', 'blowing smoke up her ass', 'blowing smoke up our ass', 'blowing smoke up their ass', 'blown away', 'blue blood', 'blue in the face', 'blunt words have the sharpest edge', 'bob is your uncle', 'bodice ripper', 'bog standard', 'boils down to', 'bone-chilling cold', 'bone dry', 'bone idle', 'bone of contention', 'bone to pick', 'bone up on', 'booby prize', 'booby trap', 'boot is on the other foot', 'booze cruise', 'bored to tears', 'born with a silver spoon in his mouth', 'born within the sound of the bow bells', 'botch the job', 'both barrels', 'the bottom line', 'bottom of the barrel', 'bought the farm', 'bounce back', 'bowl someone over', 'box yourself in', 'boys will be boys', 'bragging rights', 'brain drain', 'brand spanking new', 'break a leg', 'break the ice', 'bright as a button', 'bring home the bacon', 'bring it on', 'bring sand to the beach', 'broad in the beam', 'broke the bank', 'brother, can you spare a dime', 'brownie points', 'buck naked', 'buck stops here', 'buckle down', 'build a better mousetrap and the world will beat a path to your door', 'built like a brick sh#thouse', 'built like a tank', 'built to last', 'bum steer', 'bump in the road', 'bump on a log', 'bums on seats', 'bun in the oven', 'bunny boiler', 'burn the candle at both ends', 'burn the midnight oil', 'burn your bridges', 'burn your ships', 'burning up the track', 'bury the hatchet', 'bury your head in the sand', 'business as usual', 'business at hand', 'bust your balls', 'bust your chops', 'busting a gut', 'busy as a bear in a beehive', 'busy as a bee', 'busy as a one-armed paperhanger', 'busy as a one-legged man in an ass-kicking contest', 'busy hands are happy hands', 'but enough about me', 'butt of a joke', 'butter him up', 'butter would not melt in his mouth', 'butterflies in his stomach', 'buy a pig in a poke', 'buy something for a song', 'by all means, after you', 'by and large', 'by george', 'by gum', 'by hook or by crook', 'by the same token', 'by the skin of your teeth', 'call a spade a spade', 'call it a day', 'call off the dogs', 'call the shots', 'can of whoop ass', 'can of worms', 'get to first base', 'can not beat that with a stick', 'can not blame him for trying', 'can not blame her for trying', 'can not cut it', 'can not for the life of me remember', 'get a word in edgewise', 'have your cake and eat it too', 'hold a candle to', 'judge a book by its cover', 'learn to swim without getting in the water', 'say enough about him', 'say enough about her', "can not say's i would", 'squeeze blood out of a turnip', 'squeeze blood out of a rock', 'teach an old dog new tricks', 'can not win for losing', 'carbon copy', 'carpe diem', 'carrot on a stick', 'carry coals to newcastle', 'carry the can', 'carry the team', 'carte blanche', 'case in point', 'cash cow', 'cash in your chips', 'cash is king', 'cash it in', 'cash on the nail', 'cast a very long shadow', 'cat got your tongue', 'catch my drift', 'catch the drift', 'catch-22', 'catch a falling knife', 'catch 40 winks', 'catch hell if i do', 'catching some zs', 'cat-like grace', "cat's whiskers", 'caught between a rock and a hard place', 'caught between scylla and charybdis', 'caught by the short hairs', 'caught in the crossfire', 'caught me off-guard', 'caught red-handed', 'caught with his hands in the till', 'caught with his pants down', 'caught with your hand in the cookie jar', 'chain is only as strong as it is weakest link', 'chalk and cheese', 'champ at the bit', 'champagne tastes and a beer budget', 'change your tune', 'channel surfing', 'chapter and verse', 'charity begins at home', 'charm the pants off', 'charmed life', 'chatty cathy', 'cheap at half the price', 'cheap shot', 'cheap trick', 'check it out', "check's in the mail", 'cherchez la femme', 'chew the cud', 'chew the fat', 'chewing nails and spitting tacks', 'chick flick', 'chief cook and bottle washer', 'children should be seen and not heard', "child's play", 'chink in the armor', 'chip off the old block', 'chip on his shoulder', 'chit-chat', 'chock full', 'chock-a-block', 'chop and change', 'chow down', 'chuck-a-nana', 'clam up', 'clapped out', 'clash of the titans', 'clean as a whistle', 'clean bill of health', 'clean sweep', 'cleanliness is next to godliness', 'clear as a bell', 'clear as mud', 'clear blue water', 'clear the air', 'clear the decks', 'climb on the bandwagon', 'climbing the walls', 'close but no cigar', 'close call', 'close early and often', 'close enough for jazz', 'close only counts in horseshoes', 'close quarters', 'close ranks', 'close your eyes and think of england', 'closing the barn door after the horse has bolted', 'cloud-cuckoo-land', 'clucking and bucking with the other hens', 'clue me in', 'coast to coast', 'cock and bull story', 'cock up', 'cockles of your heart', 'coin a phrase', "cold as a witch's tit", 'cold as ice', 'cold comfort', 'cold enough to freeze the balls off a brass monkey', 'cold feet', 'cold hands, warm heart', 'cold shoulder', 'cold turkey', 'come a cropper', "come a'callin", 'come hell or high water', 'come in under the wire', 'come out of the closet', 'come up short', 'come up trumps', 'come what may', 'coming apart at the seams', 'coming down in buckets', 'coming down the pike', 'comparing apples to oranges', 'contemplate my navel', "cook one's goose", 'cook the books', 'cooking with gas', 'cool as a cucumber', 'cool britannia', 'cool your heels', 'cool your jets', 'copper-bottomed guarantee', 'cor blimey', 'cost an arm and a leg', 'cotton on to someone', 'could not do it to save his soul', 'could not do it to save his hide', 'could not fight his way out of a wet paper sack', 'could not fight his way out of a wet paper bag', 'could not make heads or tails of it', 'count your blessings', 'cover my ass', 'crack down', 'crack the code', 'crack the whip', 'cracker jack', 'cracking up', 'crammed in like sardines', 'crazy as a loon', 'crazy like a fox', 'crazy as a march hare', 'mad as a march hare', 'cream of the crop', 'credit where credit is due', 'creme de la creme', 'crime does not pay', 'crocodile tears', 'cross the line', 'crossing the rubicon', "cruisin' for a bruisin'", 'cry havoc and let slip the dogs of war', 'cry me a river', 'cry over spilled milk', 'cry wolf', 'curb your enthusiasm', 'curiosity killed the cat', 'curry favor', 'curse a blue streak', 'cut and run', 'cut corners', 'cut from the same cloth', 'cut no ice', 'cut off your nose to spite your face', 'cut the mustard', 'cut to the chase', 'cut your losses', 'cut your teeth', 'cute as a button', 'cuts like a knife', 'cuts to the core', 'cuts to the quick', 'cutting through all the red tape', 'dagger in the heart', 'knife in the heart', 'damned if you do and damned if you do not', 'dance with the devil', 'dances to the beat of a different drummer', 'moves to the beat of a different drummer', 'dangle a carrot in front of him', 'dark horse', 'darting to and fro', 'dat dawg do not hunt no more', 'david versus goliath', "davy jones' locker", 'day late and a dollar short', 'daylight robbery', 'dead as a dodo', 'dead as a doornail', 'dead ringer', 'deal with it', 'dealt a fatal blow', 'death by a thousand cuts', 'deep in thought', 'deer in headlights', 'designer stubble', 'deus ex machina', 'diamond in the rough', 'die-hard', 'different kettle of fish', 'dig yourself into a hole', 'dip your toe in the water', 'dirt cheap', 'distance makes the heart grow fonder', 'do a 180', 'do as i say and not as i do', 'do birds fly', 'do not call us, we will call you', 'do not count your chickens before they hatch', 'do not go there', 'do not have a clue', 'do not keep a dog and bark yourself', 'do not look a gift horse in the mouth', 'do not poke the bear', 'do not pull my leg', 'do not try to teach your grandma to suck eggs', 'do not throw the baby out with the bath water', 'do or die', 'do unto others as you would have other do unto you', 'do what it takes', 'does a bear sh#t in the woods', 'does not know if she is washing or hanging out', 'does not know shit from shinola', 'does not have a prayer', 'does not stand a chance', 'dog days', 'dog eat dog', 'dog in the manger', 'dog tired', 'dogs bark, but the caravan moves on', "dog's bollocks", "dog's breakfast", "dog's dinner", 'dogs have masters, cats have staff', "dog's life", 'doing the horizontal bop', 'doing time', 'done a runner', 'done to a turn', 'done up like a christmas tree', "donkey's years", 'do not air your dirty laundry in public', 'party pooper', 'a stick in the mud', "a big girl's blouse", 'bite of more than you can chew', 'bite the hand that feeds you', 'burn your bridges', 'change horses in midstream', "count your chickens before they're hatched", "do anything i wouldn't do", "fire 'til you see the whites of their eyes", 'fly off the handle', 'knickers in a twist', 'knickers in a bunch', 'panties in a bunch', 'panties in a wad', 'shorts in a bunch', 'shorts in a wad', 'do not have a cow', 'do not have two nickels to rub together', 'do not hold your breath', 'do not jump to conclusions', 'do not know him from adam', 'do not let the bed bugs bite', 'do not look a gift horse in the mouth', 'do not make a fuss', 'do not make me do something i will regret', 'do not paint the devil on the wall', 'do not pee on my leg and tell me it is raining', 'do not push your luck', 'do not put all your eggs in one basket', 'do not rock the boat', 'do not shoot me, i am just the messenger', 'do not sweat it', 'do not take any wooden nickels', 'do not tempt fate', 'do not toot your own horn', 'do not trust the lock to which everyone has a key', 'do not upset the apple cart', 'do not use a lot where a little will do', 'do not want to cover old ground', "dot the i's and cross the t's", 'double dutch', 'double whammy', 'doubting thomas', 'down and out', 'down at heel', 'down in the mouth', 'down on your luck', 'down on his luck', 'down on her luck', 'down on my luck', 'down the hatch', 'down the pan', 'down the tubes', 'down to earth', 'down to the wire', 'drain the lizard', 'draw a blank', 'draw the line', 'dream on', 'dressed to kill', 'dressed to the nines', 'drink like a fish', 'drive me to drink', 'drive me nuts', 'drive you nuts', 'drive him nuts', 'drive her nuts', 'drive us nuts', 'drive them nuts', 'drive me up a wall', 'drive you up a wall', 'drive someone doolally', 'drive the point home', 'driving your ducks to a poor pond', 'drop a dime', 'drop in the bucket', 'drop me a line', 'drop-dead gorgeous', 'dropping like flies', 'drown your sorrows', 'drum up support', 'drunk as a skunk', 'dry as a bone', 'ducks in a row', 'dumb as a post', 'dumber than a bag of hammers', 'dumber than a box of rocks', 'duvet day', 'dyed in the wool', 'a grammar guru, style editor, and writing mentor in one package', 'try it for free', 'prowritingaid', 'eager beaver', 'early bird catches the worm', 'early to bed, early to rise makes a man healthy, wealthy and wise', 'earmark something', "earn one's stripes", 'earned his wings', 'easier said than done', 'easy as 123', 'easy as abc', 'easy as pie', 'eat dirt', 'eat, drink and be merry', 'eat like a horse', 'eat my dust', 'eat my hat', "eat one's words", 'eat your heart out', 'eaten out of house and home', 'eating humble pie', 'economical with the truth', 'egg on your face', 'elementary, my dear watson', 'elephant in the room', 'elvis has left the building', 'emotional roller coaster', 'empty flattery', 'ends justify the means', 'et tu, brutus', 'even a blind squirrel finds an acorn once in a while', 'even keel', 'even stevens', 'every dark cloud has a silver lining', 'every dog has his day', 'every man for himself', 'every man has his price', 'every man has stupid thoughts, only wise men keep them quiet', 'every rose has its thorn', 'every tom, dick, and harry', 'every which way but loose', 'everyone has their cross to bear', 'everything but the kitchen sink', "everything's coming up daisies", "everything's coming up roses", "everything's copasetic", "everything's hunky dory", 'exceedingly well read', 'excuse me while i kiss this guy', 'excuse my french', 'eye for an eye, tooth for a tooth', 'eye of newt and toe of frog, wool of bat and tongue of dog', 'eye to eye', 'eyeball someone or something', 'eyeball to eyeball', 'face like a bulldog chewing on a wasp', 'face like a burst couch', 'face like a dropped meat pie', 'face only a mother could love', 'face that launched 1000 ships', 'face that would scare a dog out of a butcher shop', 'face the music', 'face up to the facts', 'fair and square', 'fair weather friend', 'fait accompli', 'faith can move mountains', 'fake it till you make it', 'fall from grace', 'fall guy', 'fall head over heels', 'fall off the back of a lorry', 'fall on your sword', 'fall through the cracks', 'famous for fifteen minutes', 'fan the flames', 'fancy free', 'fancy meeting you here', 'fancy-pants', 'far and away the best', 'far be it from me', 'far from the madding crowd', 'fashion victim', 'fast buck', 'faster than a speeding bullet', 'faster than greased lightning', 'fat as a cow', 'fat as a pig', 'fat chance', 'feast your eyes on this', 'feather in his cap', 'feed a cold, starve a fever', 'feeding frenzy', 'feel like a fifth wheel', 'fell off my plate', 'fickle finger of fate', 'fiddling while rome burns', 'fie, fi, foh, fum, i smell the blood of an englishman', 'fight fire with fire', 'fight like a man', 'fight like cats and dogs', 'fight the good fight', 'filthy rich', 'finders keepers, losers weepers', 'fine and dandy', 'fine line', 'finer than frog hair', 'fire in the belly', 'firing on all cylinders', 'first things first', 'fish or cut bait', 'fish out of water', 'fit as a fiddle', 'fit to be hung', 'fit to be tied', 'fits and starts', 'fits like a glove', 'flag something down', 'flash as a rat with a gold tooth', 'flash in the pan', 'flat as a board', 'flat as a long-poured champagne', 'flat as a pancake', 'flat out', 'flattery will get you nowhere', 'flavor of the month', 'fleet footed', 'fleet of foot', 'flesh and blood', 'flipped her lid', 'flirt with disaster', 'flog a dead horse', 'flotsam and jetsam', 'flown the coop', 'fly by night', 'fly by the seat of your pants', 'fly in the face of', 'fly in the ointment', 'fly off the handle', 'fly on the wall', 'flying by the seat of your pants', 'foam at the mouth', 'fob off', 'follow suit', 'follow the leader', 'following in his footsteps', 'fool me once, shame on you, fool me twice, shame on me', "fools' gold", 'fools rush in where angels fear to tread', 'foot in the door', 'foot loose and fancy free', 'foot the bill', 'for crying out loud', 'for ever and a day', 'for everything there is a season', "for god's sake", "for pete's sake", 'for the love of god', 'for the love of pete', 'for want of the nail, the shoe was lost', 'for whom the bell tolls', 'forbidden fruit', 'forever and a day', 'forgive them for they know not what they do', 'fork out', 'foul play', 'four corners of the earth', 'free as a bird', 'free reign', 'fresh as a daisy', 'fresh out of ideas', "fried to one's tonsils", 'friends, romans, countrymen, lend me your ears', 'frisky as a puppy', 'frog in my throat', 'from day one', 'from here to timbuktu', 'from sea to shining sea', 'from strength to strength', 'from the four corners of the earth', 'from the frying pan into the fire', 'fruit of your loins', 'fuddy-duddy', 'full monty', 'full of himself', 'full of hot air', 'full of mischief', 'full of piss and vinegar', 'full tilt', 'full to the back teeth', 'funny business', 'funny farm', 'funny you mention it', 'fur coat and no knickers', 'fuzzy wuzzy', 'gadzooks', 'gag me with a spoon', 'game is on the line', 'gang bang', 'gathering like flies', 'gave it a wide berth', 'gee whiz', 'generation x', 'genius is one percent inspiration and 99 percent perspiration', 'get the ball rolling', 'start the ball rolling', 'get a grip on yourself', 'get a handle on this', 'get a life', 'get a room', 'get a word in edgewise', 'get ahead early and stay ahead late', 'get all worked up', 'get along like oil and water', 'get an earful', 'get back up on the horse', 'get cleaned out', 'get crushed', 'get down to bare bones', 'get down to brass tacks', 'get down to the nitty gritty', 'get it outta my hair', 'get off on the wrong foot', 'get on her high horse', 'get on her soap box', "get one's goat", 'get outta town by sundown', 'get stuffed', 'get the peanut butter out of your ears', 'get the show on the road', 'get thee behind me, satan', 'get to the bottom of it', 'get with the program', 'get your arms around it', 'get your ducks in a row', 'get your feet wet', 'get your foot in the door', 'get your goat', 'get your head in the game', 'gift of the gab', 'gild the lily', 'gimme a break', 'gird your loins', 'give a hoot', 'give a little take a little', 'give a wide berth', 'give an inch, and he takes a mile', 'give and take', 'give him a run for his money', 'give it a rest', 'give it a whirl', 'give the shirt off your back', 'give them a hand', 'give up the ghost', 'give your right arm', 'given to him on a silver platter', 'giving someone the bird', 'glass ceiling', 'glimmer of hope', 'gloss over', 'glowing like a good deed in a naughty world', 'glutton for punishment', 'go against the grain', 'go and boil your head', 'go back to the well', 'go ballistic', 'go belly up', 'go berserk', 'go by the book', 'go figure', 'go fly a kite', 'go for broke', 'go head to head', 'go jump in the lake', 'go like the clappers', 'go off at half-cock', 'go out in a blaze of glory', 'go out on a limb', 'go over his head', 'go overboard', 'go the extra mile', 'go through the motions', 'go through the roof', 'go to pot', 'go to the dogs', 'go together hand in hand', 'go where the green lights lead you', 'go with the flow', 'go with your gut', 'god help us', 'god only knows', 'god speed', 'god willing', 'going against the tide', 'going bananas', 'going gang-busters', 'going nineteen to the dozen', 'going to hell in a hand basket', 'gold digger', 'golden child', 'gentlemen only, ladies forbidden', 'gone but not forgotten', 'gone to the dogs', 'good as gold', 'good as new', 'good beginning makes a good ending', 'good call', 'good fences make good neighbors', 'good man is hard to find', 'good men and true', 'good one', 'good riddance', 'good rule of thumb', 'good samaritan', 'good soldier', 'good things come to those who wait', 'good to go', 'good to the last drop', 'goody two-shoes', 'goofing off', 'gordon bennett', 'got a hole in his pocket', 'got a leg up on it', 'got a loaf in the oven', 'got beat like a drum', 'got burned', 'got him by the short hairs', 'got knocked up', 'got lost in the shuffle', 'got my mojo working', 'got off on the right foot', 'got off on the wrong foot', 'got schooled', 'got spanked', 'got taken for a ride', 'got the stuffing beat out of him', 'got them by the short and curlies', 'got under my skin', 'got whooped', 'got you over a barrel', 'got your hand caught in the cookie jar', 'got your head in the clouds', 'got your nose all pushed out of joint', 'grace of god', 'grand slam', 'grasping at straws', 'grass is always greener on the other side', 'grass up', 'graveyard shift', 'grease a palm', 'greased lightning', 'green-eyed monster', 'green with envy', 'greener pastures', 'grin and bear it', 'grin like a cheshire cat', 'grinning from ear to ear', 'grist for the mill', 'ground rules', 'groundhog day', 'growing like a weed', 'gum up the works', 'gunning for', 'guns blazing', 'had his bell rung', 'hair of the dog', 'halcyon days', 'half a bubble off', 'half a loaf is better than none', 'half cocked', 'half-baked idea', 'halt who goes there', 'hand over fist', 'handbags at dawn', 'handle it with kid gloves', 'hang by a thread', 'hang in there', 'hang me out to dry', 'hang on every word', "hanging onto mother's apron strings", 'hanky panky', 'happy as a clam', 'happy as a lark', 'happy as a pig in mud', 'happy as a pig in shit', 'happy camper', 'hard as a rock', 'hard cheese', 'hard to swallow', 'harder for a rich man to go to heaven than for a camel to go through the eye of a needle', 'hare-brained idea', 'harp on', 'haste makes waste', 'hat in hand', 'haul someone over the coals', 'have a heart', 'have a nice day', 'have an ax to grind', "have 'em in stitches", 'have the last laugh', 'have not got a penny to my name', 'have not got a row to hoe', 'have not got a row to hoe', 'have not seen hide nor hair of him', 'he breasted his cards', 'he can not see the forest for the trees', 'he could not hit the broad side of a barn', 'he does not know what time it is', 'he gave a hundred and ten percent', 'he got plastered', 'he got the short end of the stick', 'he has a few loose screws', 'he has a way with words', 'he has egg on his face', 'he is toast', 'he knows which side his bread is buttered on', 'he learned his lesson', 'he left no stone unturned', 'he let the cat out of the bag', 'he looks like death warmed up', 'he made a mad dash for it', "he never met a doughnut he didn't like", 'he put one over on me', 'he single-handedly destroyed an empire', 'he speaks with a forked tongue', 'he spilled the beans', 'he was aladdin in an orchard dripping with diamonds', 'he was just a port in the storm', 'he was talking into his hat lying', 'he was the life of the party', 'he went the whole 9 yards', 'he went to the school of hard knocks', 'university of life', 'he who can, does; he who cannot, teaches', 'he who cannot dance, blames the dj', 'he who hesitates is lost', 'he who laughs last, laughs best', 'he who lives by the sword, shall die by the sword', 'he will give the devil his due', 'he won, hands down', 'he is as dense as a london fog', 'she is as dense as a london fog', 'he silenced the critics', 'she silenced the critics', 'head over heels', 'heading for the poor house', 'heads up', 'heard it through the grapevine', 'heart of gold', 'heaven help us', 'heavens to betsy', 'hedge your bets', 'heebie-jeebies', 'hell-bent for leather', 'hell has no fury like a woman scorned', 'hell or high water', 'helter-skelter', 'hem and haw', 'hen pecked', 'her biological clock is ticking', 'here lies one whose name was writ in water', 'here today, gone tomorrow', "here's mud in your eye", "here's your hat, what is your hurry", 'he is a bald-faced liar', 'he is a bubble shy of plumb', 'he is a corn-fed hick', 'he is a dark horse', 'he is a fall guy', 'he is a smooth operator', 'he is all flibberty jibbets', 'he is all hat and no cattle', 'he is always blowing his own horn', 'he is an easy study', 'he is an inch deep and a mile wide', 'he is bitten off more than he can chew', 'he is built like a brick shit-house', 'he is changing his tune', 'he is chomping at the bit', 'he is dressed to the nines', 'he is feeling his oats', 'he is fishing for compliments', 'he is gone to ground', 'he is got a bug up his ass', 'he is got more money than he knows what to do with', 'he is got the skills to pay the bills', 'he is gunning for a fight', 'he is hen pecked', 'he is milk toast', 'he is not playing with a full deck', 'he is not the sharpest knife in the cabinet', 'he is over the hill', 'he is pulling your leg', 'he is pushing up daisies', 'he is really laying it on thick', 'he is really on the ball', 'he is scared of his own shadow', 'he is so matter-of-fact', "he is so ugly, he'd have to sneak up on a glass of water to get a drink", 'he is the south end of a north-bound horse', 'he is thinking with the wrong head', 'he is waiting for his ship to come in', 'het up', 'hide the salami', 'higgledy piggledy', 'high and dry', 'high as a kite', 'high hopes', 'high time', 'high, wide and handsome', 'high-flyer', 'highway robbery', 'hindsight is 20/20', 'his bark is worse than his bite', 'his elevator does not go to the top floor', 'his eyes are bigger than his stomach', 'his left hand does not know what his right hand is doing', 'his mouth is writing checks his body can not cash', 'hissy fit', 'history repeats itself', 'hit below the belt', 'hit every ugly branch falling out of the tree', 'hit him right between the numbers', 'hit the books', 'hit the deck', 'hit the ground running', 'hit the hay', 'hit the nail on the head', 'hit the sack', 'hoist by your own petard', 'hoity-toity', 'hold down the fort', 'hold the phone', 'hold your horses', 'holding all the cards', 'holier than thou', 'home is where the heart is', 'home is where you hang your hat', 'hook, line and sinker', 'hop, skip and a jump', 'hope against hope', 'hope springs eternal', 'horse around', 'horse of a different color', 'horse play', 'horsing around', 'hot as hell', 'hot enough for you', 'hot enough to fry an egg', 'hot off the press', 'hot on the heels', 'hot under the collar', 'hotter than a fox in a firestorm', 'houston, we have a problem', 'how are the mighty fallen', 'how do i love thee', 'how now, brown cow', "how sharper than a serpent's tooth it is to have a thankless child", "how's it hanging", "how's that for a topper", 'hugged him closer than peel does a banana', 'hump day', 'hunker down', 'hunky dory', 'hurl insults', 'hurts like the dickens', 'i beg to differ', 'i bought it for a song', 'i busted my hump', 'i can not stand it', 'i can not stomach that', 'i could eat a horse', 'i could whip you with one arm tied behind my back', "i didn't come down the clyde in a banana boat", "i didn't expect the spanish inquisition", 'i do not give a fig', 'i do not give a jot', 'i hate to say this, but', 'i have a bone to pick with you', 'i have an ax to grind', 'i have not slept one wink', 'i have nothing to declare but my genius', 'i have nothing to offer but blood, toil, tears and sweat', 'i have not a clue', 'i have not the foggiest', 'i need that like a hole in the head', 'i need that like a moose needs a hat rack', "i never met a man i didn't like", 'i ought to tan your hide', 'i put two and two together', 'i quit smoking cold turkey', 'i second that', 'i smell a rat', 'i spy with my little eye', 'i trust him as far as i can throw him', 'i want my place in the sun', 'i was roped into it', 'i was not born yesterday', 'i will give you that to boot', 'i will go to the foot of our stairs', 'i will wear my heart upon my sleeve', "i wouldn't p#ss on your teeth if they were on fire", "i wouldn't trust him as far as i could spit", 'ice water in his veins', 'ice water in her veins', 'icing on the cake', 'i would bet my bottom dollar', 'i would lose my head if it was not attached', 'i would rather be a hammer than a nail', 'i would rather have a bottle in front of me, than a frontal lobotomy', 'idle chit-chat', "idle hands are the devil's workshop", "if a frog had wings, he wouldn't bump his ass hopping", 'if a tree falls in the forest, does it make a sound', 'if at first you do not succeed, try, try, again', "if god had meant for man to fly, he would've given us wings", 'if his word were a bridge - you would be afraid to cross', 'if i had a nickel for every time he _, i would be a millionaire', 'if i had my druthers', 'if i were in his shoes', "if it ain't broke, do not fix it", "if it weren't for bad luck, i would have no luck at all", 'if it is not one thing it is another', 'if i have said it once, i have said it a thousand times', 'if looks could kill', 'if music be the food of love, play on', "if the mountain won't come to mohammed, mohammud must go to the mountain", 'if the shoe fits, wear it', 'if wishes were horses, beggars would ride', "if you can not beat 'em, join 'em", 'if you can not find it, grind it', 'if you can not kill the king then do not wound him', 'if you can not see the bottom, do not put your foot in the water', 'if you can not stand the heat, get out of the kitchen', 'if you can not take mohammed to the mountain, take the mountain to mohammed', 'if you chase two rabbits, both will escape', 'if you do not have anything nice to say, do not say anything at all', 'if you get the sense, then chuck the tense', 'if you love something set it free', 'if you play your cards right', 'if you think that, you have another think coming', 'if you were any closer, it would bite you', 'if your foresight was as good as your hindsight, we would be better by a far sight', 'if you are going to talk the talk, you better walk the walk', "if you have seen one you have seen 'em all", 'ignorance is bliss', 'ignorance of the law is no excuse', "i will be a monkey's uncle", 'i will be damned', 'i will be the judge of that, thank you', 'i will be there with bells on', 'i will bet a dollar to a donut', 'i will eat my hat', 'i will fix you', 'i will fix your little red wagon', 'i will leave you with something to chew on', 'i will procrastinate later', 'i will punch his lights out', 'i will see you in hell', 'i am going bananas', 'i am gonna clean your clock', 'i am gonna lay down the law', 'i am gonna wash that man right outta my hair', 'i am in hog heaven', 'i am not a rocket scientist', "it ain't rocket science", 'i am not getting any younger', 'i am on a roll', 'imitation is the sincerest form of flattery', 'in a new york minute', 'in a nutshell', 'in a pickle', "in a pig's eye", 'in a quandary', 'in a trice', 'in a wink', 'in an interesting condition', "in bed with one's boots on", 'in cahoots with', 'in every life a little rain must fall', 'in fine fettle', 'in for a fleecing', 'in for a penny, in for a pound', 'in for the long haul', 'in full cry', "in harm's way", "in my mind's eye", 'in one ear and out the other', 'in one fell swoop', 'in over your head', 'in seventh heaven', 'in still weather everyone is a good sailor', 'in stitches', 'got it in the bag', 'have it in the bag', 'in the black', 'in the box-seat', 'in the buff', 'in the cards', 'in the clear', 'in the doghouse', 'in the doldrums', 'in the hot seat', 'in the limelight', 'in the money', 'in the nick of time', 'in the offing', 'in the pink', 'in the red', 'in the rough', 'in the twinkling of an eye', "in 2 shakes of a lamb's tail", 'in your dreams', 'indian summer', 'innocent as the day he was born', 'irons in the fire', 'is a pig pork', 'is it soup yet', 'is nothing sacred', 'is the pope catholic', 'is this a dagger which i see before me', "isn't all it is cracked up to be", "it ain't over till the fat lady sings", "it ain't rocket science", 'it all boils down to this', 'it came like a bolt from the blue', 'it is a long road without a turn', 'it is all grist to the mill', 'it is better to give than to receive', 'it is better to light a candle than curse the darkness', "it isn't all sweetness and light", 'it just goes to show', 'it never rains but it pours', 'it sounds like a thrashing machine', 'it stands to reason', 'it takes two to tango', 'it takes two fools to argue', 'it took my breath away', 'it was a piece of cake', 'it was a white-knuckle ride', 'it was an ill-fated idea', 'it will be a cold day in hell', "it won't fly", 'it is no use crying over spilled milk', 'it is a dog-eat-dog world', "its a dog's life", 'it is a doozy', 'it is a freckle past a hair', 'it is a game of inches', 'it is a lemon', 'it is a long shot', 'it is a one-horse town', 'its a sure thing', 'it is a wash', 'it is all cut and dried', 'it is all fun and games until someone loses an eye', 'it is all greek to me', 'it is all in your head', 'it is all over but the crying', 'its all topsy turvy', 'it is an ill wind that blows no good', 'it is autumn in her mouth and all her tongue can do is rustle', 'it is better than a poke in the eye with a sharp stick', 'it is cutting edge', 'it is darkest just before the dawn', 'it is got a great beat, but you can not dance to it', 'it is in the bag', 'it is just one of those days, i guess', 'it is like my daddy used to say', 'it is neck and neck', 'it is never too late to learn', 'it is not a sprint, it is a marathon', 'it is not all it is cracked up to be', 'it is not over till it is over', 'it is not the heat it is the humidity', 'it is not the size of the dog in the fight, it is the size of the fight in the dog', 'it is not whether you win or lose, it is how you play the game', 'it is not written in stone', 'it is nothing earth-shattering', 'it is on the tip on my tongue', 'it is only a matter of time', 'it is raining like a cow pissing on a flat rock', 'it is what is on the inside that counts', 'i have been had', 'got a monkey on my back', 'got it covered', 'got other fish to fry', 'had it up to here', 'ivory tower', 'jack of all trades and a master of none', 'jockeying for position', 'join the ranks', 'joined at the hip', 'journey of 1000 miles begins with the first step', 'jump down your throat', 'jump in with both feet', 'jump on the bandwagon', 'jump the gun', 'jury is still out', "just a cotton pickin' minute here", 'just a drop in the bucket', 'just a minute', 'just a second', 'just admiring the view', 'just around the bend', 'just as sweet as you please', 'just fell off the turnip truck', 'just like riding a bike', 'just the tip of the iceberg', 'just thought i would throw that in', 'just washed my hair and can not do a thing with it', 'just what the doctor ordered', 'justice is blind', 'kangaroo court', 'kangaroo loose in the top paddock', "keep a bad dog with you, and the good dogs won't bite", 'keep a stiff upper lip', 'keep a wide berth', 'keep an eye on you', 'keep my eye on you', 'keep body and soul together', 'keep danger at bay', "keep 'em flying", 'keep your spirits up', 'keep it down', 'keep it simple, stupid', 'keep it under your hat', 'keep it up', 'keep on your toes', 'keep schtum', 'keep something at bay', 'keep the ball rolling', 'keep the home fires burning', 'keep up with the joneses', 'keep your fingers crossed', 'keep your chin up', 'keep your eye on the ball', 'keep your eyes open', 'keep your eyes peeled', 'keep your hair on', 'keep your nose to the grindstone', 'keep your pants on', 'keep your pecker up', 'keep your powder dry', 'keep your shirt on', 'keep your shoulder to the wheel', 'keep your thoughts to yourself', 'keeping on top of it', 'staying on top of it', 'keeping the world safe for democracy', 'keeps her cards close to her chest', 'keeps on ticking', 'keepy-uppy', 'kettle of fish', 'kick back', "kick 'em when they're down", 'kick him to the curb', 'kick her to the curb', 'kick some butt', 'kick some ass', 'kick the bucket', 'kick your heels', 'kicked in the huevos', 'took it in the huevos', 'kid in a candy store', "kill 'em with kindness", 'king of the hill', "king's ransom", 'kiss and tell', 'kiss ass', 'kiss of death', 'kissing the rose', 'kitten on the keys', 'knee-high to a grasshopper', 'knee-jerk reaction', "knock 'em dead", 'knock it off', 'knock it out of the park', 'knock off', 'knock-off', 'knock on wood', 'knock the cover off the ball', 'knock your socks off', 'knock yourself out', 'knocked into a cocked hat', 'knocked up', 'know it like the back of my hand', 'know the ropes', 'know the score', 'know what is up', 'know where you stand', 'know which side your bread is buttered on', 'know which way the wind blows', 'know your onions', 'knows it chapter and verse', 'knuckle down', 'knuckle sandwich', 'wondering what else prowritingaid can do check out the prowritingaid editing software:', 'la dolce vita', 'la-di-da', 'lager frenzy', 'lamb to the slaughter', 'lame duck', 'land of milk and honey', 'lardy-dardy', 'lark about', 'last but not least', 'last-ditch effort', 'last hurrah', 'last, but not least', 'laugh a minute', 'laugh like a drain', 'laughing all the way to the bank', 'laughing-stock', 'laughter is the best medicine', 'lay down the law', 'lay it on with a trowel', 'lay it out in lavender', 'lay my cards on the table', 'lay my cards out on the table', 'lead-pipe cinch', 'learn the ropes', 'least said, soonest mended', 'leave your mark', 'make your mark', 'leave no stone unturned', 'left at the altar', 'left in the lurch', 'left-handed compliment', 'legend in his own mind', 'leopard does not change its spots', 'less is more', 'lesser of two evils', 'let a thousand flowers bloom', 'let bygones be bygones', "let god sort 'em out", 'let me bend your ear', 'let not the sun go down on your wrath', 'let sleeping dogs lie', 'let the cat out of the bag', 'let them eat cake', 'let there be light', 'let your hair down', "let's forge ahead, shall we", "let's get the ball rolling", "let's roll", "let's split", "let's tie the knot", 'level playing field', 'lick into shape', 'lickety-split', "licking one's wounds", 'lie down with dogs and wake up with fleas', 'lie low', 'life goes on', 'life in the fast lane', 'life is a bowl of cherries', 'life is like a box of chocolates, you never know what you are going to get', 'life is not all beer and skittles', 'life is what you make it', 'life of riley', 'life stinks', "life's a b#tch", "life's too short", 'lift myself up by the bootstraps', 'lift your game', 'get your act together', 'light a fire under it', 'light as a feather', 'light at the end of the tunnel', 'light in the loafers', 'lighter than air', 'lightning never strikes the same place twice', 'lights are on but there is nobody home', 'like a bat out of hell', 'like a broken record', 'like a bull in a china shop', 'like a chicken with his head cut off', 'like a coiled spring', 'like a dog chasing cars', 'like a duck on a june bug', 'like a fish out of water', 'like a lost dog in the high weeds', 'like a moth to a flame', 'like balling the jack', 'like being savaged by a dead sheep', 'like billy-o', 'like butter', 'like chalk and cheese', 'like father, like son', 'like flies on sh#t', 'like getting your tit in the wringer', 'like it is going out of style', 'like lambs to the slaughterhouse', 'like looking for a needle in a haystack', 'like oil and water', 'like pigs in a poke', 'like sh#t off a shovel', 'like shooting ducks on a pond', 'like shooting fish in a barrel', 'like taking candy from a baby', 'like the dickens', 'like there is no tomorrow', 'like walking on eggshells', "like water off a duck's back", 'like white on rice', 'lily-livered', 'line in the sand', 'lions led by donkeys', "lion's share", 'lipstick on a pig', 'little of this, a little of that', 'little strokes fell great oaks', 'live and learn', 'live and let live', 'live long and prosper', 'living hand to mouth', 'living high off the hog', 'living in an ivory tower', 'living legend', 'living off the fat of the land', 'living on borrowed time', 'living the life of riley', 'lo and behold', 'load of cobblers', 'load of codswallop', 'loaves and fishes', 'lock, stock, and barrel', 'long and short of it', 'long arm of the law', 'long in the tooth', 'long shot', 'long time no see', 'long ways away', 'look a gift horse in the mouth', 'look before you leap', 'look into your heart', 'look out for number one', 'look over your shoulder', 'looking at the world through rosy colored glasses', 'looking for a needle in a haystack', 'looks can be deceiving', 'looks like there is a new sheriff in town', 'loose cannon', 'loose lips sink ships', 'loose your shirt', "lord willin' and the creek do not rise", 'lose face - save face', 'lose your lunch', 'lose your marbles', 'lose your mind', 'lost a step', 'lost his shirt', 'lots of honey makes bees lazy', 'love and hate are two horns on the same goat', 'love conquers all', 'love is a many-splendored thing', 'love is blind', 'love thy neighbor', "lower than a snake's belly", 'lower the boom', 'luck of the draw', 'lucky stiff', 'lying through your teeth', 'mad as a hatter', 'mad as a march hare', 'madder than a wet hen', 'made in the shade', 'made it by the skin of my teeth', 'made of money', 'make a bee-line for', 'make a big deal out of nothing', 'make a break for it', 'make a fast buck', 'make a long story short', 'make a mountain out of a mole hill', 'make a statement without saying a word', 'make a virtue of necessity', 'make an ass out of yourself', 'make ends meet', 'make hay while the sun shines', 'make heads or tails of', 'make him an offer he can not refuse', 'make like a baby and head out', 'make like a tree and leave', 'make money hand over fist', 'make no bones about it', 'make or break', 'make out like a bandit', 'make the grade', 'make tracks', 'make waves', 'make your move', 'makes my blood boil', 'makes your hair stand on end', "makin' bacon", 'making him sing like a canary', 'making money hand over fist', 'making the beast with two backs', 'making whoopee', 'mal de mer', 'man does not live by bread alone', 'man for all seasons', 'man up', "man's best friend", 'many a true word is spoken in jest', 'many are called but few are chosen', 'many hands make light work', 'march to the beat of a different drummer', 'mark my words', 'marked man', 'marking time', 'marry in haste, repent at leisure', 'matter-of-fact', 'may you live in interesting times', 'maybe something will jog your memory', 'mea culpa', 'mean as a snake', 'meet and greet', 'melting pot', 'memory like an elephant', 'ménage à trois', 'methinks she doth protest too much', 'mighty oaks from little acorns grow', 'milk it for all it is worth', 'milk of human kindness', 'mind over matter', 'mind your manners', 'mind your own beeswax', 'mind your own business', "mind your p's and q's", 'misery loves company', 'missed by a hair', 'missed the boat', 'moaning minnie', 'monday morning quarterback', 'money burns a hole in his pocket', 'money can not buy you happiness', 'money does not grow on trees', 'money grubbing', 'money is the root of all evil', 'money makes the world go round', 'out the wazoo', 'monkey business', 'monkey see monkey do', 'monkeying around', "montezuma's revenge", 'many a mickle makes a muckle', 'more cliches than you can shake a stick at', 'more fool you', 'more fun than a barrel of monkeys', 'more honoured in the breach than in the observance', 'more than meets the eye', 'more the merrier', 'more things change, the more they stay the same', 'more we learn, the less we know', 'moving the goalposts', 'much ado about nothing', 'much of a muchness', 'mud slinging', 'mug for the camera', 'mumbo jumbo', "mum's the word", "murphy's law", 'my bad', 'my better half', 'my brain is fried', 'my cup runneth over', 'my giddy aunt', 'my hair was on end', 'my hands are tied', "my hat's off to you", 'my head is swimming', 'my heart sank', 'my little black book', "my mind's eye", 'my stomach is tied up in knots', 'my way or the highway', 'nail your colors to the mast', 'naked as a jaybird', 'naked as the day you were born', 'namby-pamby', 'name and shame', 'name that tune', 'name will be mud', 'name your poison', 'nary a word was spoken', 'nasty, brutish and short', "nature's first green is gold", 'near and dear to my heart', 'necessary evil', 'necessity is the mother of invention', 'needs must', 'neither a borrower not a lender be', 'neither fish nor flesh, nor good red herring', 'neither fish nor fowl', 'neither here nor there', 'nerves of steel', 'nervous as a cat on a hot tin roof', 'nervous as a long tailed cat in a room full of rocking chairs', 'nervous as a whore in church', 'never cast a clout till may be out', 'never give a sucker an even break', 'never hurts to try', 'never in a month of sundays', 'never put off until tomorrow what you can do today', 'never say never', 'never the twain shall meet', 'never-never land', 'new kid on the block', 'new lease on life', 'nice cage, no bird', 'nice day for a picnic', 'nice guys finish last', 'nice work, if you can get it', "nine days' wonder", 'nip and tuck', 'nip it in the bud', 'nitty-gritty', 'no accounting for taste', 'no dice', 'no go', 'no guts, no glory', 'no holds barred', "no if's, and's, or but's about it", 'no man is an island', 'no more cakes and ale', 'no one here but us chickens', 'no pain, no gain', 'no rest for the wicked', 'no shit, sherlock', 'no skin off my back', 'no skin off my nose', 'no strings attached', 'no use crying over spilled milk', 'no victory without a battle', "no way on god's green earth", 'no way, josé', 'nod off', 'none of your business', 'none too pleased', 'noodle on', 'nose in the air', 'not a spinning wheel in the kingdom and then you prick your finger', 'not all it is cracked up to be', 'not by the hair of my chinny chin chin', 'not enough room to swing a cat', 'not for all the tea in china', 'not for nothing, but', 'not just another pretty face', 'not my cup of tea', 'not playing with a full deck', 'not rowing with both oars', 'not the brightest bulb', 'not the ghost of a chance', 'not the sharpest knife in the cabinet', 'not worth a hill of beans', 'nothing is certain but death and taxes', 'nothing is impossible for those who do not have to do it themselves', 'nothing new under the sun', 'nothing personal', 'nothing succeeds like success', 'nothing to fear but fear itself', 'nothing to sneeze at', 'nothing to write home about', 'nothing up my sleeve', 'nothing ventured, nothing gained', 'now is the winter of our discontent', 'now or never', "now this won't hurt a bit", "now's as good a time as any", "now's your chance", 'numb as a hake', 'nutty as a fruitcake', 'o romeo, romeo wherefore art thou romeo', 'o ye, of little faith', 'object of desire', 'odds bodkins', 'off and running', 'off like a prom dress', 'off the cuff', 'off the dime', 'off the hook', 'off the record', 'off the shelf', 'off the top of my head', 'off with his head', 'off your rocker', 'oh, to be a fly on the wall', 'oh, woe is me', 'okey-dokey', 'old as dirt', 'old as the hills', 'old ball and chain', 'old blowhard', 'old fogey', 'old habits die hard', 'old school', 'old standby', 'on a good footing', 'on a hiding to nothing', 'on a lark', 'on a roll', 'on a short leash', 'on a soap box', 'on a wild goose chase', 'on a wing and a prayer', 'on bended knee', 'on carey street', 'on cloud nine', 'on equal footing', 'on him like ugly on an ape', 'on par', 'on pins and needles', 'on queer street', 'on skid row', 'on tenterhooks', 'on the back burner', 'on the ball', 'on the cutting edge', 'on the dole', 'on the dot', 'on the double', 'on the edge of your seat', 'on the fly', 'on the front burner', 'on the grapevine', 'on the house', 'on the lam', 'on the other hand', 'on the qt', 'on the road again', 'on the run', 'on the same page', 'on the take', 'on the tip of my tongue', 'on the up and up', 'on the wagon', 'on the warpath', 'on the whole', 'on to something', 'on your tod', 'on your toes', 'once bitten, twice shy', 'once in a blue moon', 'once in a blue moon', "once in a dog's age", 'once more unto the breach, dear friends, once more', 'one bad apple spoils the barrel', 'one bad apple spoils the bushel', 'one bad apple spoils the lot', 'one bad apple spoils the bunch', 'one brick short of a load', 'one foot on a banana peel, the other in the grave', 'one for the books', 'one for the road', 'one good turn deserves another', 'one in million', "one man's foul weather is another man's fair", "one man's garbage is another man's treasure", "one man's meat is another man's poison", 'one size fits all', 'one small step for a man, a giant leap for mankind', 'one stop shop', 'one taco short of a combination plate', 'one toe over the line', 'one-hit wonder', "one's heart's content", 'oops-a-daisy', 'open a can of worms', 'open and shut case', 'open mouth, closed mind', 'open mouth, closed ears', 'open season', 'open the kimono', 'opened a can of worms', 'opportunity does not knock twice', 'opposites attract', 'out for a sunday stroll', 'out like a light', 'out of pocket', 'out of sight, out of mind', 'out of sorts', 'out of the blue', 'out of the frying pan and into the fire', 'out of the jaws of death', 'out of the mouths of babes and sucklings', 'out of the woods', 'out of whack', 'out sowing your wild oats', 'out to lunch', 'out with the old, in with the new', 'over a barrel', 'over and done with', 'over and over again', 'went over my head', 'over the edge', 'over the hill', 'over the moon', 'over the top', 'pack it in', 'packing heat', 'packing lead', 'paddle your own canoe', 'pain in the ass', 'pain in the neck', 'pain in the butt', 'pain in the hole', 'paint oneself into a corner', 'paint the town red', 'pan out', "pandora's box", 'paper over the cracks', 'paper tiger', 'par for the course', 'pardon my french', 'part and parcel', 'parting shot', 'pass away', 'pass the buck', 'pass the hat', 'passed with flying colors', 'pat on the back', 'path of least resistance', 'patience is a virtue', "pay a king's ransom", 'pay an arm and a leg', 'pay as you go', 'pay attention to details', 'pay lip service', 'pay the debt of nature', 'pay the piper', 'pay through the nose', 'payback is a b#tch', 'peaches and cream complexion', 'pearls before swine', 'pears for your heirs', 'peas in a pod', 'peel the onion', 'peel back the onion', 'peel out', 'peeping tom', 'pell-mell', 'pencil me in', 'pennies from heaven', 'penny for your thoughts', 'penny pincher', 'penny saved is a penny earned', 'penny wise and pound foolish', "people who live in glass houses shouldn't throw stones", 'perception becomes reality', 'pester power', 'petered out', 'phone it in', 'physician, heal thyself', 'pick and mix', 'pick of the litter', 'pick over the ruins', 'pick the low-hanging fruit', 'picture perfect', "picture's worth a thousand words", 'pie in the sky', 'piece of cake', 'pig and whistle', 'pig in a poke', 'pig out', 'pigeon-chested', "pig's ear", 'pin money', 'pin your hopes on something', 'pipe down', 'pipe dream', 'piping hot', 'piss like a racehorse', 'pissed to the gills', 'pissing in the wind', 'piss-poor', 'plain and simple', 'plain as day', 'plain sailing', 'play ball', 'play both ends against the middle', 'play by ear', 'play fast and loose', 'play for the name on the front of your jersey, not the name on the back of your jersey', 'play hot potato', 'play it again, sam', 'play it by ear', 'play second fiddle to', 'play the cards you are dealt', 'play the final card', 'play the giddy goat', 'play with the big boys', 'played me for a fool', 'playing hardball', 'playing possum', 'playing the field', 'playing with fire', 'pleased as punch', 'plenty of other fish in the sea', "plenty to go 'round", 'poison the well', 'poker face', 'poor as a church mouse', 'pop a vein', 'pop goes the weasel', 'posh - port out, starboard home', 'possession is nine-tenths of the law', 'pot calling the kettle black', 'pot of gold at the end of the rainbow', 'pound for pound', 'pound of flesh', 'pound the pavement', 'pour it on thick', 'pour oil on trouble waters', 'power corrupts: absolute power corrupts absolutely', 'power dressing', 'powers of darkness', 'practice makes perfect', 'pray to the porcelain god', 'praying at the porcelain altar', 'preaching to the choir', 'press into service', 'pretty as a picture', 'pretty damn quick', 'pretty penny', 'prick up your ears', 'pride before the fall', 'prime time', 'primed to the sticking point', 'primrose path', 'pull a fast one', 'pull a rabbit out of a hat', 'pull out all the stops', 'pull the wool over your eyes', 'pull your chain', 'pull your finger out', 'pull your head out of your ass', 'pull yourself up by your bootstraps', 'punch his lights out', 'punched in the gut', 'pure as the driven snow', 'push the envelope', 'push your buttons', 'put a cork in it', 'put a lid on it', 'put a little elbow grease into it', 'put a sock in it', 'put it through its paces', 'put my two cents in', 'put on ice', 'put on your thinking cap', 'put out some feelers', 'put paid to', 'put that in your pipe and smoke it', 'put the cart before the horse', 'put the dampers on', 'put the pedal to the metal', 'put two and two together', 'put up your feet and stay awhile', 'put your back up', 'put your best foot forward', 'put your foot in your mouth', 'put your heart into it', 'put your money where your mouth is', 'put your nose out of joint', 'putting his feet to the fire', 'putting the cart before the horse', 'putting the screws to him', 'pyrrhic victory', 'queen for a day', 'queer as a three dollar bill', 'quick buck', 'quicker than a new york minute', 'quiet as a mouse', 'quiet as a church mouse', 'quit horsing around', 'quit while you are ahead', 'rack and ruin', 'rack your brains', 'rag, tag and bobtail', 'raining cats and dogs', 'raining stair-rods', 'raise the bar', 'raise the roof', 'raking in the dough', 'raking it in', 'rally round', 'rattle trap', 'rattle your cage', 'raw end of the deal', 'raze to the ground', 'read between the lines', 'read it and weep', 'read the fine print', 'read the handwriting on the wall', 'reading the riot act', 'real mccoy', 'red carpet treatment', 'red herring', 'red in tooth and claw', 'red letter day', "red sky in the morning, sailor's warning; red sky at night, sailor's delight", 'religion is the opium of the people', 'reopen an old wound', 'rest assured', "resting on one's laurels", 'rhyme or reason', 'richard of york gave battle in vain', 'riding the wild pony', 'right as rain', 'right on the button', 'right on the money', 'right on the nose', 'right up your alley', 'ring a bell', "ring a ring o'roses, a pocketful of posies, atishoo, atishoo, all fall down", 'ring in the new year', 'ring of truth', 'ring the changes', 'rise and shine', 'road less traveled', 'road to hell is paved with good intentions', 'road to hell is paved on all sides with good intentions', 'roaring fire', 'robbing peter to pay paul', 'roll of the dice', 'roll out the red carpet', 'roll over in his grave', 'roll with the punches', 'rolling in the dough', 'rolling stone gathers no moss', 'rome was not built in a day', 'room to swing a cat', 'rotten to the core', 'rough around the edges', 'rough as a cob', 'rub salt in the wound', 'rub your nose in it', 'rub your face in it', 'rubbing salt in his wounds', 'rubs me the wrong way', 'rule with an iron fist', 'rules are made to be broken', 'run a mile', 'run amok', 'run circles around', 'run for your money', 'run it up the flagpole', 'run like the wind', 'run out of steam', 'run the gauntlet', 'run with the fox and bark with the hounds', 'running around like a chicken with its head cut off', 'running with wolves', 'runs like a top', 'sacred cow', 'safe and sound', 'sail off into the sunset', 'ride off into the sunset', 'salad days', "same ol' same ol'", 'same song and dance', 'save the drama for your mama', 'save your breath', 'saved by the bell', 'savoir faire', 'sawing a log', 'say what you will,', 'say your prayers', "scarce as hen's teeth", 'scared dogs bark most', 'scared of his own shadow', 'scared stiff', 'scaredy-cat', 'scattered to the four winds', 'scot free', 'scraping the bottom of the barrel', 'screaming bloody murder', 'scuse me while i kiss this guy', 'sealed with a loving kiss', 'second wind', 'see a man about a dog', 'see eye to eye', 'see no evil, hear no evil, speak no evil', 'see the glass as half empty', 'see the whole field', 'see the world through rose colored glasses', 'see which way the winds blow', 'see you later, alligator', 'seeing red', 'seems just like old times', 'sell yourself short', 'send packing', 'sent to coventry', 'separate the men from the boys', 'separate the wheat from the chaff', 'serve up a softball', "set one's cap at", 'set your teeth on edge', 'seven-year itch', 'sh#t or get off the pot', 'sh#t out of luck', 'shaggy dog story', 'shake a leg', "shake hands with the wife's best friend", "shall i compare thee to a summer's day", 'shape up or ship out', 'share and share alike', 'sharp as a marble', 'sharp as a tack', 'she could test the patience of job', 'she drinks like a fish', 'she fell out of the ugly tree and hit every branch on the way down', 'she gave me a withering glance', 'she got called up on the carpet', 'she has a great personality', 'she has a green thumb', 'she has bats in her belfry', 'she has everything but the kitchen sink', 'she has pull', 'she has clout', 'she is a loose cannon', 'she threw a wet blanket on my idea', 'she wears her heart on her sleeve', "she wouldn't know me from adam", 'shed light on', 'shed some light on', 'she is a peach', 'she is all that', 'she is an open book', 'she is been hit with an ugly stick', 'she is burning her candle at both ends', 'she is fighting a losing battle', 'she is getting the red carpet treatment', 'she is got eyes in the back of her head', 'she is got money to burn', 'she is hot to trot', 'she is in hot water', 'she is lost her marbles', 'she is not the brightest bulb on the patio', 'she is not the only fish in the sea', 'she is out sowing her wild oats', 'she is out to lunch', 'she is taking the bait', 'she is tugging on your chain', 'shilly-shally', 'ship-shape and bristol fashion', 'shirt off his back', 'shit for brains', 'shit happens', 'shiver me timbers', 'shoe is on the other foot', 'shoestring budget', 'shoot from the hip', 'shoot it straight', 'shoot the breeze', 'shoot yourself in the foot', 'shooting for the moon', 'short changed', 'short end of the stick', 'short pleasures are often long regretted', 'short shrift', 'shot across the bows', 'shot in the dark', 'shotgun wedding', 'shove off', 'show him the door', 'show me the money', 'show some spine', 'show some spunk', 'show them how the cow ate the cabbage', 'show your true colors', 'shuffle off this mortal coil', 'shut the hole in your head', 'shut your hole', 'shut your cake-hole', 'shut your mouth', 'sick as a dog', 'sick to death of it', 'signed, sealed and delivered', 'silence is golden', 'silenced the crowd', 'silly billy', 'silver bullet', 'simple pleasures are the best', 'sing for your supper', 'sing like a bird', 'sink or swim', 'sink your teeth into', 'sit tight', 'sitting duck', 'sitting in the catbird seat', 'sitting on pins and needles', 'sitting on the fence', 'six of one, half a dozen of another', 'six feet under', 'skating on thin ice', 'skeletons in the closet', 'skid row', 'slam dunk', 'slap on the back', 'sleep like a baby', 'sleep like a log', 'sleep with the fishes', 'sleeping her way to the top', 'slick as snot on a glass doorknob', 'slipped through your fingers', 'slippery as an eel', 'slippery slope', 'sloppy as a soup sandwich', 'slow and steady wins the race', 'slow as molasses in january', 'sly as a fox', 'smack dab in the middle', 'small potatoes', "small world, isn't it", 'smart alec', 'smart ass', 'smart cookies do not crumble', 'smart is better than stupid', 'smarter than the average bear', 'smile and the world smiles with you, cry and you cry alone', 'smoke and mirrors', 'smoking gun', "smooth as a baby's bottom", 'smooth operator', "snail's pace", "snowball's chance in hell", 'snug as a bug in a rug', 'so close, you can taste it', 'so many men so little time', 'so much bad in the best of us and so much good in the worst in us that it ill-behoves us to talk about the rest of us', 'so much for that', 'so quiet you could hear a pin drop', 'so sue me', "so ugly, they'd have to sneak up on a glass of water to get a drink", 'sod off', 'sold down the river', 'solid as a rock', 'some pots you do not stir', 'some things are better left unsaid', 'someday, you will thank me for this', 'something rotten in the state of denmark', 'something smells fishy', 'something you can really sink your teeth into', 'sometimes you are the hydrant, and sometimes you are the dog', 'sometimes you are the windshield, and sometimes you are the bug', 'sometimes you just gotta let your hair down', 'son of a b#tch', 'son of a gun', 'sound like a broken record', 'sounds like a plan', 'sour grapes', 'spare the rod, spoil the child', 'speak of the devil', 'speak off the cuff', 'speak softly and carry a big stick', 'speak with a forked tongue', 'speaking in riddles', 'spend a penny', 'spick and span', 'spill the beans', 'spin a yarn', 'spineless wimp', 'spinning your wheels', 'spit in one hand and wish in the other, and see which one you have the most in', 'spit the dummy', 'spitting image', 'split second', 'splitting hairs', 'spoil the fun', 'spread the word', 'spruce up', 'square meal', 'squeaky bum time', 'stack the deck', 'stand and deliver', 'standing on the shoulders of giants', 'stand-up guy', 'star-crossed lovers', 'staring off into space', 'staring off into nowhere', 'stark-raving mad', 'start from scratch', 'state of the art', 'stay tuned', 'stayed too long at the fair', 'staying power', 'steal a march', "steal one's thunder", 'stealing the show', 'steer clear of it', 'stem the tide', "step on a crack, break your mother's back", 'step on it', "stepping on people's toes", 'stick a fork in it', 'stick a fork in me', 'stick a fork in her', 'stick a fork in him', 'stick in the mud', 'stick it in your ear', 'stick it out', 'stick it to you', 'stick it where the sun do not shine', 'stick to your guns', 'stick up for the little guy', 'stick with it', 'sticks and stones will break my bones, but words will never hurt me', 'sticks out like a sore thumb', 'sticky subject', 'stiff as a board', 'stiffen the sinews', 'still as a church mouse', 'still waters run deep', 'stinking to high heaven', "stir up an ant's nest", 'stirring up trouble', 'stitch in time saves nine', 'stone the crows', "stone's throw away", 'stop and smell the roses', 'stop on a dime', 'stop the presses', 'straight and narrow', 'straight as an arrow', 'straight from the horses mouth', 'straighten up and fly right', 'strain at the leash', 'stranger danger', 'stranger in a strange land', 'stress out', 'stretch a dollar', 'strike while the iron is hot', 'string him along', 'strong as an ox', 'stubborn as a mule', 'stuck in a rut', 'stuck out like a sore thumb', 'stuff and nonsense', 'stuffed shirt', 'stump up', 'stupid is as stupid does', 'success has a thousand fathers while failure is an orphan', 'such is life', 'suck up', 'sugarcoat something', 'survival of the fittest', 'suspension of disbelief', "swallow one's pride", 'swan song', 'sweat the details', 'sweating blood', 'sweating like a pig', 'sweep it under the rug', 'sweet 16 and never been kissed', 'sweet deal', 'sweeten the pot', 'sweetheart deal', 'swim against the tide', 'swim up stream', 'swim with the sharks', 'swimming in molasses', 'swing the lead', 'a grammar guru, style editor, and writing mentor in one package', 'try it for free', 'prowritingaid', 'tackle my homework', 'tail between his legs', 'tail wagging the dog', 'take a back seat to', 'take a breather', 'take a dive', 'take a dump', 'take a hike', 'take a leak', 'take a long walk off a short plank', 'take a picture, it will last longer', 'take a step back', 'take by storm', 'take care of your knitting', 'take down a peg or two', 'take five', 'take him to task', 'take it and run with it', 'take it at face value', 'take it easy', 'take it from me', 'take it like a man', 'take it on the lam', 'take it or leave it', 'take it to the limit', 'take it with a grain of salt', 'take one for the team', 'take potluck', 'take someone down a peg', 'take stock of', 'take the bit between your teeth', 'take the bull by the horns', 'take the crowd out of the game', 'take the day off', 'take the easy way out', 'take the gloves off', 'take the guilt off the gingerbread', 'take the mickey', 'take the plunge', 'take the wind out of your sails', 'take the world by storm', 'take this job and shove it', 'take umbrage', 'take with a pinch of salt', 'take your fate into your own hands', 'take your life in your own hands', 'taken for a ride', 'takes its toll on you', 'taking his pound of flesh', 'taking the scenic route', 'talk of the devil', 'talk to the hand', 'talk until you are blue in the face', 'talking behind his back', 'talking out of your head', 'tall, dark and handsome', 'tall tale', 'tarred and feathered', 'taste of your own medicine', 'teach him to fish', "teacher's pet", 'tear into it', 'tear you a new #sshole', 'teflon president', 'tell a porkie', 'tell it to me straight', 'tell it to the marines', 'tell your story walking', 'tempest in a teacup', 'ten to one', 'tend the garden', 'test the waters', "testing one's mettle", 'thank god it is friday', 'thank goodness', 'thank your lucky stars', 'that and a quarter will get you a cup of coffee', 'that argument does not hold water', 'that baby runs like a scalded dog', 'that burns me up', 'that chaps my hide', "that dog won't hunt", 'that gets my goat', 'that hits the spot', 'that is all, folks', 'that is one small step for a man, one giant leap for mankind', 'that oughta tide you over', 'that really brings it home', 'that sucks', 'that takes the cake', 'that was cold-blooded', 'that which does not kill you makes you stronger', 'that will be the day', 'that is a doozy', 'that is a joke', 'that is a load off my mind', 'that is a real stem-winder', 'that is a wrap', 'that is about the size of it', 'that is bogus', 'that is easy for you to say', 'that is enough to piss off the pope', 'that is for the birds', 'that is how the cow eats the cabbage', 'that is icing on the cake', 'that is it in a nutshell', 'that is just like the pot calling the kettle black', 'that is just peachy', 'that is just the tip of the iceberg', 'that is like a turtle on a fence post', 'that is no joke', 'that is old hat', 'that is par for the course', 'that is pretty run-of-the-mill', 'that is rubber on the side of the road', 'that is skull duggery', 'that is some ole good', 'that is the $64,000 question', 'that is the long and short of it', 'that is the ticket', 'that is the way lady luck dances', 'that is the way the ball bounces', 'that is the way the cookie crumbles', 'that is the whole ball of wax', 'that is water under the bridge', 'the acorn does not fall far from the tree', 'the back of beyond', 'the balance of power', "the bee's knees", 'the belle of the ball', 'the best thing since little apples', 'the best things in life are free', 'the big apple', 'the big cheese', 'the big easy', 'the bigger they are the harder they fall', 'the bitter end', 'the blind leading the blind', 'the bottom line', 'the bowels of the earth', 'the bread of life', 'the buck stops here', 'the butler did it', 'the call of the wild', 'the camera cannot lie', "the cat's meow", "the cat's pajamas", "the cat's whiskers", 'the chickens come home to roost', 'the cold shoulder', 'the collywobbles', 'the course of true love never did run smooth', 'the crack of doom', 'the cream of the crop', 'the customer is always right', 'the cut of your jib', 'the darkest hour is just before the dawn', 'the darling buds of may', 'the devil incarnate', 'the devil is always ready to rock the cradle of the saint who sleeps', 'the devil is in the details', 'the devil made me do it', 'the devil must be beating his wife', 'the devil takes the hindmost', 'the devil to pay', 'the die has been cast', 'the dog ate my homework', 'the early bird catches the worm', 'the elephant in the room', 'the exception that proves the rule', 'the eyes are the mirrors of the soul', 'the eyes are the mirrors to the soul', 'the face that launched a thousand ships', 'the female of the species is more deadly than the male', 'the fickle finger of fate', 'the fifth beatle', 'the floozie in the jacuzzi', 'the fly in the ointment', 'the full monty', 'the game is afoot', 'the game is up', 'the girl next door', 'the gospel truth', 'the grass is always greener on the other side', 'the great unwashed', 'the greatest thing since sliced bread', 'the hairy eyeball', 'the hand that rocks the cradle', 'the heebie-jeebies', 'the last straw', 'the left hand does not know what the right hand is doing', "the light's on but nobody's home", 'the living daylights', 'the long arm of the law', 'the lord giveth and the lord taketh away', 'the lord moves in mysterious ways', 'the love that dare not speak its name', 'the lowest on the totem pole', 'the luck of the draw', 'the melting pot', 'the more the merrier', 'the more things change, the more they stay the same', 'the more we learn, the less we know', 'the moving finger writes', "the mutt's nuts", 'the nail that sticks up gets pounded down', 'the naked truth', 'the night is young and so are we', 'the nth degree', 'the old ball and chain', 'the one that got away', 'the only difference between women and girls is the price of their pearls', 'the only people i trust are you and me, and i am not too sure about you', 'the only thing we have to fear is fear itself', 'the order of the boot', 'the pen is mightier than the sword', 'the penny drops', 'the pick of the litter', 'the place was crawling with cops', 'the pot calling the kettle black', 'the powers that be', 'the proof is in the pudding', 'the quiet before the storm', 'the real mccoy', 'the road less travelled', 'the road to ruin is paved with good intentions', 'the road to hell is paved with good intentions', 'the seven-year itch', "the shoe's on the other foot", 'the show must go on', "the sky's the limit", 'the squeaky wheel gets the grease', "the straw that broke the camel's back", 'the stronger the breeze the stronger the trees', 'the strongest steel is cast in the hottest fire', 'the strongest winds blow on the highest mountains', 'the tables are turned', 'the tail that wagged the dog', 'the tale of the tape', 'the third degree', "the tide's beginning to turn", 'the triumph of hope over experience', 'the truth hurts', 'the twilight years', 'the unkindest cut of all', 'the usual suspects', 'the whole kit and caboodle', 'the whole nine yards', 'the whole shebang', "the whole shootin' match", 'the world is your oyster', 'the writing is on the wall', 'the year dot', 'the yellow peril', "them's fightin' words", 'there are starving children in africa', 'there are three kinds of lies', 'there for the taking', 'there is a god', 'there is more than one way to skin a cat', 'there is no alternative', 'there is no cow on the ice', 'there is no i in team', 'there is no such thing as a free lunch', 'there is no time like the present', 'there now, that was not so bad, was it', 'there ought to be a law against that', 'there, but for the grace of god, go i', 'there will be hell to pay', 'there is a first time for everything', 'there is a god and i am not him', 'there is a sucker born every minute', 'there is an r in the month', 'there is gold in them thar hills', 'there is more than one way to skin a cat', 'there is more where that came from', 'there is no place like home', 'there is no such thing as a free lunch', 'there is no time like the present', 'there is one in every crowd', 'there is something fishy about that', 'there is something i have been meaning to tell you', 'they gave him carte blanche', 'they need to take care of the rock', 'they play good d', 'they threw the book at him', "they're getting hitched", "they're jumping the broomstick", "they're like two peas in a pod", 'thick and thin', 'thick as a brick', 'thick as a ditch', 'thick as pea soup', 'thick headed', "thin as six o'clock", 'things are not always as they seem', "things aren't what they used to be", 'things that go bump in the night', 'think like a man, act like a woman', 'think outside the box', 'thinking with the wrong head', "third time's a charm", 'third time lucky', 'third wheel', 'thirty 30000 foot level', 'this could be the start of something big', 'this hurts me worse than it does you', 'this is for the birds', "this town's not big enough for the two of us", 'thorn in my side', 'those who do not look back from where they come from, will not reach their destination', 'thou shalt not kill', 'though this be madness, yet there is method in it', 'three-score years and ten', 'three sheets to the wind', 'three strikes and you are out', 'threw a curve ball', 'threw it with a little something on it', 'threw up my hands', 'through thick and thin', 'throw me a bone', 'throw me some scraps', 'throw your hat in the ring', 'throw my hat in the ring', 'throw a fit', 'throw a monkey wrench into the works', 'throw cold water on', 'throw gas on the fire', 'throw gasoline on the fire', 'throw in the towel', 'throw someone to the wolves', 'throw the baby out with the bathwater', 'throw the book at him', 'throw your hat into the ring', 'throwing caution to the wind', 'throwing out the baby with the bathwater', 'thumb your nose at', 'ticked off', 'tickle the ivories', 'tickled pink', 'tie the knot', 'tied to her apron strings', 'tied up right now', 'tight as a drum', 'tight as the bark on a tree', 'tight wad', 'tighten your belt', "tighter than a gnat's ass", 'till the cows come home', 'tilting at windmills', 'time after time', 'time and again', 'time and tide wait for no man', 'time flies when you are having fun', 'time heals all wounds', 'time is money', 'time is of the essence', 'time is running out', 'time is up', 'time of your life', 'time on your hands', 'time stands still', 'time to pay the piper', 'time waits for no man', 'time will tell', 'time-honored', "time's up", 'times, they are a changing', 'timing is everything', 'tin ear', 'tingling with anticipation', 'tit for tat', 'tits-up', 'to a t', 'to assume makes an ass out of u and me', 'to badger someone', 'to be beside yourself', 'to be fed up', 'to be honest with you', 'to be or not to be', 'to be young and foolish', 'to beat the band', 'to boldly go where no man has gone before', 'to boot', 'to cast the first stone', 'to chance your arm', 'to close ranks', 'to cry wolf', 'to each his own', 'to egg on', 'to err is human, to forgive divine', 'to fall foul', 'to feather your nest', 'to fork out', 'to go the whole hog', 'to harp on', 'to have a field day', 'to have a gammy leg', 'to have cold feet', "to hedge one's bets", 'to hell in a hand basket', 'to knock the tar out of', 'to beat the tar out of', 'to know beans', 'to lark about', 'to lie down with lions', 'to live from hand to mouth', 'to play hookey', 'to run amok', "to save one's bacon", 'to shoot the crow', 'to skin a cat', 'to take aback', 'to talk gibberish', 'to tell you the truth', 'to the bitter end', 'to the manner born', 'to the nth degree', 'to the victor go the spoils', 'to toy with', 'to travel hopefully is a better thing than to arrive', 'to wreak havock', 'today is the first day of the rest of your life', 'toe the line', 'toe-curling', 'tomorrow is another day', 'tongue in cheek', 'tongue lashing', 'tongue tied', 'too many chefs spoil the broth', 'too many chefs spoil the soup', 'too many chiefs and not enough indians', 'too many cooks spoil the broth', 'too much information', 'too much of a good thing', 'too much sail for a small craft', 'too rich for my blood', 'toodle-oo', 'took me to the cleaners', 'took off like a bat out of hell', 'took off like a shot', 'toot his own horn', 'tooth and nail', 'top dog', 'top notch', 'top of the morning', 'topsy turvy', 'tore up from the floor up', 'torn asunder', 'toss your cookies', 'touch and go', 'touchy-feely', 'tow the line', 'train of thought', 'tread lightly', 'treated like a dog', 'tried and true', 'trip over your tongue', 'trip the light fantastic', 'trojan horse', "trouble with a capital `t'", 'truth is stranger than fiction', 'truth will out', 'try as i might', 'try your hand at something', 'trying to put a square peg in a round hole', 'tuckered out', 'tugging at heartstrings', 'tune out', 'turn a blind eye', 'turn on a dime', 'turn over a new leaf', 'turn the other cheek', 'turn the tables', 'turn up trumps', 'twelve good men and true', 'twice as nice', 'twice as strong as an ox and half as smart', 'twiddling your thumbs', 'twist my arm', 'twist of fate', 'two-faced', 'two heads are better than one', 'two left feet', 'two ships passing in the night', "two cents' worth", 'two left feet', 'two of a kind', 'two sides of the same coin', 'two wrongs do not make a right', "two's company, three's a crowd", 'u is part of us', 'ugly as a hat full of holes', 'ugly as a mud fence', 'ugly as sin', 'unbeknownst to me', 'unbeknownst to him', 'unbeknownst to her', 'unbeknownst to them', 'unbeknownst to us', 'under a microscope', 'under her thumb', 'under my skin', 'under my wing', 'under the gun', 'under the knife', 'under the sauce', 'under the weather', 'uneasy lies the head that wears a crown', 'unless you are the lead dog, the view never changes', 'unlucky at cards, lucky in love', 'until the cows come home', 'up a blind alley', 'up a creek without a paddle', 'up a gum tree', 'up for grabs', 'up in arms', 'up sh#t creek', 'up the ante', 'up the creek without a paddle', 'up the duff', 'up to his ears in trouble', 'up to snuff', 'uphill battle', 'upper crust', 'upper hand', 'ups-a-daisy', 'upset the apple cart', 'upsy-daisy', 'oopsy-daisy', 'urban myth', 'useless as tits on a boar hog', 'using a sledgehammer to crack a nut', 'find more great editing tips in our self-editing school series:', 'spice of life', 'wait and see', 'wait for the ink to dry', 'waiting for the dust to settle', 'waiting for the other shoe to drop', 'waiting for your ship to come in', 'waiting in the wings', 'waiting with baited breath', 'wake the dead', 'wake up and smell the coffee', 'wake up living', 'wake-up call', 'waking up on the wrong side of the bed', 'waking up with the chickens', 'walk on the wild side', 'walk softly and carry a big stick', 'walk the plank', 'walking on air', 'walking on eggshells', 'walking on sunshine', 'walled garden', 'walls have ears', 'walls start closing in', 'want my place in the sun', 'warts and all', 'wash your hands of something', 'wash your mouth out with soap', 'waste not, want not', 'watch and wait', 'watch your mouth', 'watched pot never boils', 'watching the clock', 'water, water everywhere, but not a drop to drink', 'wave the white flag', "way to a man's heart is through his stomach", 'way to go, einstein', 'we are not amused', 'we few, we happy few, we band of brothers', 'we have seen better days', 'we know where you live', 'wear many hats', 'wear the trousers', 'wear your heart on your sleeve', "wearing nothin' but his birthday suit", 'wearing the big girlie blouse', 'weasel words', 'weather the storm', 'welcome to my world', 'welcome to the club', "we'll cross that bridge when we come to it", 'well, how do you like them apples', "we'll jump that fence when we get to it", 'went belly up', 'went over like a lead balloon', 'went storming off in a huff', 'went through the roof', 'we are going to burn the midnight oil', 'we are gonna tie one on tonight', 'we are not in kansas anymore', 'we are really going to town', 'we are sitting ducks', 'were you born in a barn', 'were you raised by wolves', 'wet behind the ears', 'we have hit paydirt', "wham, bam, thank you ma'am", 'what a blast', 'what a duck', 'what a piece of work is man', 'what a tangled web we weave', 'what a way to go', 'what am i, chopped liver', 'what are you like', 'what are you stewing about', 'what are you chicken', 'what does that have to do with the price of tea in china', 'what god has joined together, let no man put asunder', 'what goes around comes around', 'what goes up, must come down', 'what in tarnation', 'what is not to like', 'what is the skinny', 'what is up doc', 'what on earth is wrong with me', 'what part of no do not you understand', 'what rock did you crawl out from under', 'what you see is what you get', 'whatever does not kill you makes you stronger', 'whatever floats your boat', 'whatever tickles your fancy', 'whatever turns you on', 'what is a little __ among friends', "what is cookin', good lookin'", 'what is going down', 'what is good for the goose is good for the gander', 'what is he been smoking', 'what is in a name that which we call a rose by any other smells just as sweet', 'what is up with that', 'what is wrong with this picture', 'when all is said and done', 'when hell freezes over', 'when in rome, do as romans do', 'when it comes to the crunch', 'when it rains, it pours', 'when life gives you lemons, make lemonade', 'when pigs fly', 'when push comes to shove', "when the cat's away, the mouse will play", 'when the chips are down', 'when the going gets tough, the tough get going', 'when the lion is dead, the hares jump on his back', 'when the shit hits the fan', 'when the tide goes out the rocks begin to show', 'when you lie with dogs, you catch fleas', 'when you start picking out people you start leaving people out', 'where do you draw the line', 'where the rubber meets the road', 'where there is muck there is brass', 'where there is smoke, there is fire', 'where is the beef', 'whet your appetite', 'while away the hours', 'while the tailor rests, the needle rusts', 'while you live, tell truth and shame the devil', 'whipping boy', 'whistle down the wind', 'whistle for it', 'whistle in the dark', 'white as a sheet', 'white bread', 'white elephant', 'white knuckle ride', 'who could forget', 'who died and left you in charge', 'who died and made him king', 'who died and made him god', 'who pissed in your cheerios', 'whoever dies with the most toys wins', 'whole nine yards', "whole shootin' match", 'whoop it up', 'whoops-a-daisy', "who's the man", 'why buy the cow when the milk is free', 'why close the barn door after the horse is gone', "why do today what you can put off 'til tomorrow", 'why do not we all chip in', "why on god's green earth", "widow's peak", 'wig out', 'wild and woolly', 'wild goose chase', 'willy-nilly', 'win hands down', 'win one for the gipper', 'wing and a prayer', 'wing it', 'winning combination', "winning isn't everything", 'wipe the slate clean', 'wish on a star', 'wish you were here', 'wishy washy', 'witch hunt', 'with a grain of salt', 'with bated breath', 'with one hand tied behind my back', 'with tongue firmly planted in cheek', 'woe is me', "wolf in sheep's clothing", 'women and children first', 'wool gathering', 'word for word', 'work into a lather', 'work like a dog', 'work the crowd', 'work the room', 'work to a deadline', 'work your fingers to the bone', 'worker bee', 'working my last good nerve', 'world of hurt', 'world of trouble', 'world on a string', 'world weary', 'worm has turned', 'worry wart', 'worth its salt', 'worth its weight in gold', 'worthless as tits on a boar', "wouldn't touch with a barge-pole", "kick her outta bed for eatin' crackers", "kick him outta bed for eatin' crackers", 'wound tighter than a spring', 'wrong end of the stick', 'wrong side of the tracks', 'yank your chain', "you ain't seen nothin' yet", 'you bet your boots', 'you can catch more flies with honey than with vinegar', 'you can dish it out, but you sure can not take it', 'you can lead a horse to water, but you can not make him drink', 'you can lead a horticulture, but you can not make her think', 'you can never be too rich or too blonde', 'you can never go home again', "you can pick your friends and you can pick your nose, but you can not pick your friend's nose", 'you can say that again', 'you can take that to the bank', 'you can tell the men from the boys by the price of their toys', 'walked a mile in their shoes', 'walk a mile in their shoes', 'fit a square peg in a round hole', 'have your cake and eat it too', 'judge a book by its cover', 'learn to swim without getting in the water', "make a silk purse out of a sow's ear", 'put anything past her', 'put the toothpaste back in the tube', 'squeeze blood out of a turnip', 'stop him you can only hope to contain him', 'swing a dead cat', 'take knickers off a bare arse', 'teach an old dog new tricks', 'you could have knocked me over with a feather', 'you could put your eye out', 'you do not have a leg to stand on', 'you do not miss the water till the well runs dry', 'you drive me crazy', 'you drive me nuts', 'you drive me up the wall', 'you got it coming to you', 'you got your just desserts', 'you gotta put your foot down', 'you have to break a few eggs to make an omelette', 'you have to separate the chaff from the wheat', "you have to stand for something or you'll fall for anything", 'you hit the nail on the head', 'lie like a dog', 'lie like a rug', 'you lost me', 'made your bed, now your gonna have to lie in it', 'make a better door than a window', 'out of your mind', 'crawl before you can walk', 'row with the oars that you have', 'only hurt the one you love', 'only live once', 'reap what you sow', 'say potayto, i say potahto', 'scratch my back, and i will scratch yours', 'snooze, you loose', 'throw filth on the living and flowers on the dead', 'wash my back, i will wash yours', 'win some you lose some', 'will know it when you see it', 'young loins', 'young, dumb and full of rum', 'your ass is grass', 'your father was not a glass maker', 'your goose is cooked', 'your name is mud', 'your place or mine', 'a good egg', 'you are dead meat', 'driving me insane', 'you are going to get it', 'off your rocker', 'off his rocker', 'off her rocker', 'off their rocker', "the gleam in your father's eye", 'have got a nerve', 'have got some nerve', 'you have got more front than myers', 'zigged when he should have zagged', 'zigged when she should have zagged', 'zip it', 'zip your lip', 'what a zoo', 'past history', 'with all my heart', 'by a whisker', 'wishful thinking', 'thick and fast', 'from the sublime to the ridiculous', 'black as pitch', 'through and through', 'dead of night', 'nick of time', 'in a trice', 'at long last', 'blah blah blah', 'full circle', 'put two and two together', 'wishful thinking', 'now or never', 'thick and fast', 'sooner or later', 'talk turkey', 'nook and cranny', 'words fail me', 'through and through', 'sigh of relief', 'in a word', 'believe it or not', 'sixth sense', 'from head to toe', 'dead of night', 'the last straw', 'think twice', 'evil eye', 'too good to be true', 'nick of time', 'sinking feeling'}


CLICHE_PROCESSOR = KeywordProcessor(case_sensitive=False)

for cliche in CLICHES:
    CLICHE_PROCESSOR.add_keyword(cliche)
